/* ---rgf, 2003-03-10, 2003-03-05, 2003-04-16, 2003-04-22 , 2003-06-01
   tests the BSF4Rexx installation, queries all version information;
   can be invoked directly or via Java, e.g. "rexxj testBSF4Rexx.rex"
*/

if rxFuncQuery("BSF") = 1 then   /* BSF() support not loaded yet ? */
do
   call rxFuncAdd "BsfLoadFuncs", "BSF4Rexx", "BsfLoadFuncs"
   call BsfLoadFuncs
   call BsfLoadJava
end

crlf="0d0a"x         /* CR-LF character      */
tab="09"x            /* TAB character        */
tmp=    "<table border cellpadding='3px' width='100%'>" crlf
tmp=tmp "<tr><th colspan='2' width='100%'>" "BSF4Rexx Installation Information" "("||date("s") time()")" crlf crlf
tmp=tmp "</table>" crlf
tmp=tmp crlf "<p>" crlf


parse version version
tmp=tmp "<table border cellpadding='3px' align='center'>" crlf
tmp=tmp crlf crlf "<tr><th colspan='2'> Information on BSF4Rexx"
tmp=tmp tab "<tr><th style='text-align:right;'>" 'Rexx interpreter: ' "<td>" pp(version)         crlf

tmp=tmp tab "<tr><th style='text-align:right;'>" 'BSF4Rexx (DLL/so):' "<td>" pp(bsfVersion())    crlf
tmp=tmp tab "<tr><th style='text-align:right;'>" 'Java Rexx engine: ' "<td>" pp(bsf("version"))  crlf crlf

text="by Rexx which loaded Java"
if BsfInvokedBy()=1 then text="via Java"
tmp=tmp tab "<tr><th style='text-align:right;'>" "Rexx script invocation:"
tmp=tmp "<td>" "<em>" pp(text) "</em>" "<hr>" crlf crlf

   call BsfQueryRegisteredFunctions "s."
   tmp=tmp "The following BSF-functions are registered with Rexx:"

   tmp=tmp tab "<ol>" crlf
   do i=1 to s.0
      tmp=tmp tab tab "<li>" pp(s.i) crlf
   end
   tmp=tmp tab "</ol>" crlf

tmp=tmp crlf crlf "<tr><th colspan='2'> Information on Java"

   /* show the Java version in use for this invocation */
str="os.name os.version os.arch"
str=str "java.specification.version java.version"                     ,
        "java.compiler java.vm.vendor java.vm.info java.vm.version"   ,
        "java.vm.specification.vendor"  ,
        "java.vm.specification.version java.vm.specification.name"            ,
        "path.separator file.separator file.encoding"                 ,
        "java.home java.io.tmpdir user.dir"

do i=1 to words(str)
   tmp=tmp tab make_tr( word(str, i) ) crlf
end


path_separator =bsf('invoke', 'System.class', 'getProperty', 'path.separator' )

str="java.ext.dirs  java.class.path java.library.path sun.boot.class.path sun.boot.library.path"
do i=1 to words(str)
   tmp=tmp tab break_up(word(str, i), path_separator) crlf
end

tmp=tmp "</table>" crlf

say tmp
exit

pp: procedure
   tag="kbd"
   return "<"tag">"arg(1)"</"tag">"

break_up: procedure expose crlf tab /* break up path */
   parse arg key, separator
   path=bsf('invoke', 'System.class', 'getProperty', key)

   tmp=""
   do while path <> ""
      if pos(separator, path) > 0 then trailer=separator
                                  else trailer=""
      parse var path junk (separator) path
      tmp=tmp tab tab tab "["pp(junk)"]" trailer
      if path <> "" then tmp=tmp "<br>"
      tmp=tmp crlf
   end
   return "<tr><th style='text-align:right;' width='30%'>" key "<td>" tmp

make_tr: procedure expose crlf tab
   parse arg key
   return "<tr><th style='text-align:right;' width='30%'>" key "<td>" pp(bsf('invoke', 'System.class', 'getProperty', key ))

